#include <iostream>
#include <stack>
#include <algorithm>

using namespace std;

int doMagic(string str) {
    int result = 0;
    size_t openIndex = str.find('(',0);
    size_t closeIndex = str.rfind(')',1);

    if(openIndex != string::npos && closeIndex != string::npos) {
        if(openIndex == 0 && closeIndex == str.length()-1) {
            return doMagic(str);
        }
        else if(closeIndex != str.length()-1) {

        }
        result = doMagic(str.substr(openIndex+1,closeIndex-openIndex-1));
    }



    size_t mulIndex = str.find('*',0);

    if(mulIndex != string::npos) {
        string strLeft = str.substr(0,mulIndex);
        string strRight = str.substr(mulIndex+1);
        result = doMagic(strLeft) * doMagic(strRight);
    }


    seg_tree.solve();














    return result;
}

int main(){
    int numberOfTests = 8;

    for (int j = 0; j < numberOfTests; ++j) {
        int n, result = 0;
        char current, prev;

        stack<char> stack;
        cin >> n;

        for (int i = 0; i < n; ++i) {
            cin >> current;
            if (i) {
                if (prev == ')' && current == '(') stack.push('*');
                else if (prev == '(' && current == ')') stack.push('1');
                else if (prev == ')' && current == ')') {
                    stack.push('+');
                    stack.push('1');
                }
            }
            stack.push(current);
            prev = current;
        }

        string debugString;
        while (!stack.empty()) {
            debugString += stack.top();
            stack.pop();
        }
        reverse(debugString.begin(), debugString.end());
        cout << debugString << endl;

        cout << doMagic(debugString) << endl;
    }


    return 0;
}